﻿using DocuSignAPI.APIService;
using EnvelopeCreatorProject.Models.Signers;
using System;
using System.Collections.Generic;

namespace EnvelopeCreatorProject.Models.Recipients
{
    internal class InPersonSigners : SignerRecipients
    {
        private readonly HostSigner _host;

        internal InPersonSigners(int totalCount, List<Tab> signTabs, List<Tab> initialsTabs, List<Tab> dataSignFields, HostSigner host)
            : base(totalCount, signTabs, initialsTabs, dataSignFields)
        {
            _host = host;
        }

        protected override void AddData(Recipient objRecipient)
        {
            if (_host == null || string.IsNullOrEmpty(_host.HostEmail) || string.IsNullOrEmpty(_host.HostName))
                throw new ArgumentNullException("HostSigner not supplied for In-Person signing");

            AddRecipientInPersonInfo(objRecipient);
            AddSignatureInfoTo(objRecipient);
            AddSignTabs(objRecipient);

        }

        private void AddRecipientInPersonInfo(Recipient objRecipient)
        {
            _recipients.AppendLine("\"hostEmail\":\"" + _host.HostEmail + "\",");
            _recipients.AppendLine("\"hostName\":\"" + _host.HostName + "\",");
            _recipients.AppendLine("\"signerName\":\"" + objRecipient.UserName + "\",");
            _recipients.AppendLine("\"signerEmail\":\"" + objRecipient.Email + "\",");
            _recipients.AppendLine("\"roleName\":\"" + objRecipient.RoleName + "\",");

            AddRecipientCommonInfo(objRecipient);     
        }

        internal override string GetRecipientsData()
        {
            return "\"inPersonSigners\":[" + base.GetRecipientsData() + "]";
        }

    }
}
